# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.arm_brokerage_api_core_v1alpha1_server_credential import ArmBrokerageApiCoreV1alpha1ServerCredential  # noqa: F401,E501
from swagger_server.models.io_k8s_api_core_v1_resource_requirements import IoK8sApiCoreV1ResourceRequirements  # noqa: F401,E501
from swagger_server import util


class ArmBrokerageApiCoreV1alpha1Node(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, id: str=None, name: str=None, physical_node: str=None, credential: ArmBrokerageApiCoreV1alpha1ServerCredential=None, resources: IoK8sApiCoreV1ResourceRequirements=None):  # noqa: E501
        """ArmBrokerageApiCoreV1alpha1Node - a model defined in Swagger

        :param id: The id of this ArmBrokerageApiCoreV1alpha1Node.  # noqa: E501
        :type id: str
        :param name: The name of this ArmBrokerageApiCoreV1alpha1Node.  # noqa: E501
        :type name: str
        :param physical_node: The physical_node of this ArmBrokerageApiCoreV1alpha1Node.  # noqa: E501
        :type physical_node: str
        :param credential: The credential of this ArmBrokerageApiCoreV1alpha1Node.  # noqa: E501
        :type credential: ArmBrokerageApiCoreV1alpha1ServerCredential
        :param resources: The resources of this ArmBrokerageApiCoreV1alpha1Node.  # noqa: E501
        :type resources: IoK8sApiCoreV1ResourceRequirements
        """
        self.swagger_types = {
            'id': str,
            'name': str,
            'physical_node': str,
            'credential': ArmBrokerageApiCoreV1alpha1ServerCredential,
            'resources': IoK8sApiCoreV1ResourceRequirements
        }

        self.attribute_map = {
            'id': 'id',
            'name': 'name',
            'physical_node': 'physicalNode',
            'credential': 'credential',
            'resources': 'resources'
        }
        self._id = id
        self._name = name
        self._physical_node = physical_node
        self._credential = credential
        self._resources = resources

    @classmethod
    def from_dict(cls, dikt) -> 'ArmBrokerageApiCoreV1alpha1Node':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The armBrokerage.api.core.v1alpha1.Node of this ArmBrokerageApiCoreV1alpha1Node.  # noqa: E501
        :rtype: ArmBrokerageApiCoreV1alpha1Node
        """
        return util.deserialize_model(dikt, cls)

    @property
    def id(self) -> str:
        """Gets the id of this ArmBrokerageApiCoreV1alpha1Node.

        Node ID.  # noqa: E501

        :return: The id of this ArmBrokerageApiCoreV1alpha1Node.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id: str):
        """Sets the id of this ArmBrokerageApiCoreV1alpha1Node.

        Node ID.  # noqa: E501

        :param id: The id of this ArmBrokerageApiCoreV1alpha1Node.
        :type id: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def name(self) -> str:
        """Gets the name of this ArmBrokerageApiCoreV1alpha1Node.

        Node name.  # noqa: E501

        :return: The name of this ArmBrokerageApiCoreV1alpha1Node.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name: str):
        """Sets the name of this ArmBrokerageApiCoreV1alpha1Node.

        Node name.  # noqa: E501

        :param name: The name of this ArmBrokerageApiCoreV1alpha1Node.
        :type name: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def physical_node(self) -> str:
        """Gets the physical_node of this ArmBrokerageApiCoreV1alpha1Node.

        physical node running this virtual node if the physical node is not provided the node ID will be used   # noqa: E501

        :return: The physical_node of this ArmBrokerageApiCoreV1alpha1Node.
        :rtype: str
        """
        return self._physical_node

    @physical_node.setter
    def physical_node(self, physical_node: str):
        """Sets the physical_node of this ArmBrokerageApiCoreV1alpha1Node.

        physical node running this virtual node if the physical node is not provided the node ID will be used   # noqa: E501

        :param physical_node: The physical_node of this ArmBrokerageApiCoreV1alpha1Node.
        :type physical_node: str
        """

        self._physical_node = physical_node

    @property
    def credential(self) -> ArmBrokerageApiCoreV1alpha1ServerCredential:
        """Gets the credential of this ArmBrokerageApiCoreV1alpha1Node.


        :return: The credential of this ArmBrokerageApiCoreV1alpha1Node.
        :rtype: ArmBrokerageApiCoreV1alpha1ServerCredential
        """
        return self._credential

    @credential.setter
    def credential(self, credential: ArmBrokerageApiCoreV1alpha1ServerCredential):
        """Sets the credential of this ArmBrokerageApiCoreV1alpha1Node.


        :param credential: The credential of this ArmBrokerageApiCoreV1alpha1Node.
        :type credential: ArmBrokerageApiCoreV1alpha1ServerCredential
        """

        self._credential = credential

    @property
    def resources(self) -> IoK8sApiCoreV1ResourceRequirements:
        """Gets the resources of this ArmBrokerageApiCoreV1alpha1Node.


        :return: The resources of this ArmBrokerageApiCoreV1alpha1Node.
        :rtype: IoK8sApiCoreV1ResourceRequirements
        """
        return self._resources

    @resources.setter
    def resources(self, resources: IoK8sApiCoreV1ResourceRequirements):
        """Sets the resources of this ArmBrokerageApiCoreV1alpha1Node.


        :param resources: The resources of this ArmBrokerageApiCoreV1alpha1Node.
        :type resources: IoK8sApiCoreV1ResourceRequirements
        """

        self._resources = resources
